package info.textgrid.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import info.textgrid.model.Basket;
import info.textgrid.model.BasketModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the Basket service. Represents a row in the &quot;textgridrep_Basket&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link info.textgrid.model.BasketModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link BasketImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see BasketImpl
 * @see info.textgrid.model.Basket
 * @see info.textgrid.model.BasketModel
 * @generated
 */
public class BasketModelImpl extends BaseModelImpl<Basket>
    implements BasketModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a basket model instance should use the {@link info.textgrid.model.Basket} interface instead.
     */
    public static final String TABLE_NAME = "textgridrep_Basket";
    public static final Object[][] TABLE_COLUMNS = {
            { "uuid_", Types.VARCHAR },
            { "basketId", Types.BIGINT },
            { "userId", Types.BIGINT },
            { "textgridUri", Types.VARCHAR },
            { "order_", Types.INTEGER }
        };
    public static final String TABLE_SQL_CREATE = "create table textgridrep_Basket (uuid_ VARCHAR(75) null,basketId LONG not null primary key,userId LONG,textgridUri VARCHAR(75) null,order_ INTEGER)";
    public static final String TABLE_SQL_DROP = "drop table textgridrep_Basket";
    public static final String ORDER_BY_JPQL = " ORDER BY basket.order ASC";
    public static final String ORDER_BY_SQL = " ORDER BY textgridrep_Basket.order_ ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.info.textgrid.model.Basket"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.info.textgrid.model.Basket"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.info.textgrid.model.Basket"),
            true);
    public static long TEXTGRIDURI_COLUMN_BITMASK = 1L;
    public static long USERID_COLUMN_BITMASK = 2L;
    public static long UUID_COLUMN_BITMASK = 4L;
    public static long ORDER_COLUMN_BITMASK = 8L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.info.textgrid.model.Basket"));
    private static ClassLoader _classLoader = Basket.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] { Basket.class };
    private String _uuid;
    private String _originalUuid;
    private long _basketId;
    private long _userId;
    private String _userUuid;
    private long _originalUserId;
    private boolean _setOriginalUserId;
    private String _textgridUri;
    private String _originalTextgridUri;
    private int _order;
    private long _columnBitmask;
    private Basket _escapedModel;

    public BasketModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _basketId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setBasketId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _basketId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return Basket.class;
    }

    @Override
    public String getModelClassName() {
        return Basket.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("uuid", getUuid());
        attributes.put("basketId", getBasketId());
        attributes.put("userId", getUserId());
        attributes.put("textgridUri", getTextgridUri());
        attributes.put("order", getOrder());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        String uuid = (String) attributes.get("uuid");

        if (uuid != null) {
            setUuid(uuid);
        }

        Long basketId = (Long) attributes.get("basketId");

        if (basketId != null) {
            setBasketId(basketId);
        }

        Long userId = (Long) attributes.get("userId");

        if (userId != null) {
            setUserId(userId);
        }

        String textgridUri = (String) attributes.get("textgridUri");

        if (textgridUri != null) {
            setTextgridUri(textgridUri);
        }

        Integer order = (Integer) attributes.get("order");

        if (order != null) {
            setOrder(order);
        }
    }

    @Override
    public String getUuid() {
        if (_uuid == null) {
            return StringPool.BLANK;
        } else {
            return _uuid;
        }
    }

    @Override
    public void setUuid(String uuid) {
        if (_originalUuid == null) {
            _originalUuid = _uuid;
        }

        _uuid = uuid;
    }

    public String getOriginalUuid() {
        return GetterUtil.getString(_originalUuid);
    }

    @Override
    public long getBasketId() {
        return _basketId;
    }

    @Override
    public void setBasketId(long basketId) {
        _basketId = basketId;
    }

    @Override
    public long getUserId() {
        return _userId;
    }

    @Override
    public void setUserId(long userId) {
        _columnBitmask |= USERID_COLUMN_BITMASK;

        if (!_setOriginalUserId) {
            _setOriginalUserId = true;

            _originalUserId = _userId;
        }

        _userId = userId;
    }

    @Override
    public String getUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
    }

    @Override
    public void setUserUuid(String userUuid) {
        _userUuid = userUuid;
    }

    public long getOriginalUserId() {
        return _originalUserId;
    }

    @Override
    public String getTextgridUri() {
        if (_textgridUri == null) {
            return StringPool.BLANK;
        } else {
            return _textgridUri;
        }
    }

    @Override
    public void setTextgridUri(String textgridUri) {
        _columnBitmask |= TEXTGRIDURI_COLUMN_BITMASK;

        if (_originalTextgridUri == null) {
            _originalTextgridUri = _textgridUri;
        }

        _textgridUri = textgridUri;
    }

    public String getOriginalTextgridUri() {
        return GetterUtil.getString(_originalTextgridUri);
    }

    @Override
    public int getOrder() {
        return _order;
    }

    @Override
    public void setOrder(int order) {
        _columnBitmask = -1L;

        _order = order;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            Basket.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public Basket toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (Basket) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        BasketImpl basketImpl = new BasketImpl();

        basketImpl.setUuid(getUuid());
        basketImpl.setBasketId(getBasketId());
        basketImpl.setUserId(getUserId());
        basketImpl.setTextgridUri(getTextgridUri());
        basketImpl.setOrder(getOrder());

        basketImpl.resetOriginalValues();

        return basketImpl;
    }

    @Override
    public int compareTo(Basket basket) {
        int value = 0;

        if (getOrder() < basket.getOrder()) {
            value = -1;
        } else if (getOrder() > basket.getOrder()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof Basket)) {
            return false;
        }

        Basket basket = (Basket) obj;

        long primaryKey = basket.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        BasketModelImpl basketModelImpl = this;

        basketModelImpl._originalUuid = basketModelImpl._uuid;

        basketModelImpl._originalUserId = basketModelImpl._userId;

        basketModelImpl._setOriginalUserId = false;

        basketModelImpl._originalTextgridUri = basketModelImpl._textgridUri;

        basketModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<Basket> toCacheModel() {
        BasketCacheModel basketCacheModel = new BasketCacheModel();

        basketCacheModel.uuid = getUuid();

        String uuid = basketCacheModel.uuid;

        if ((uuid != null) && (uuid.length() == 0)) {
            basketCacheModel.uuid = null;
        }

        basketCacheModel.basketId = getBasketId();

        basketCacheModel.userId = getUserId();

        basketCacheModel.textgridUri = getTextgridUri();

        String textgridUri = basketCacheModel.textgridUri;

        if ((textgridUri != null) && (textgridUri.length() == 0)) {
            basketCacheModel.textgridUri = null;
        }

        basketCacheModel.order = getOrder();

        return basketCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(11);

        sb.append("{uuid=");
        sb.append(getUuid());
        sb.append(", basketId=");
        sb.append(getBasketId());
        sb.append(", userId=");
        sb.append(getUserId());
        sb.append(", textgridUri=");
        sb.append(getTextgridUri());
        sb.append(", order=");
        sb.append(getOrder());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(19);

        sb.append("<model><model-name>");
        sb.append("info.textgrid.model.Basket");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>uuid</column-name><column-value><![CDATA[");
        sb.append(getUuid());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>basketId</column-name><column-value><![CDATA[");
        sb.append(getBasketId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>userId</column-name><column-value><![CDATA[");
        sb.append(getUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>textgridUri</column-name><column-value><![CDATA[");
        sb.append(getTextgridUri());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>order</column-name><column-value><![CDATA[");
        sb.append(getOrder());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
